/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDerived;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CSourceText;
import com.ibm.etools.c.CTypedElement;
import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangPackage;
import com.ibm.etools.tdlang.impl.TDLangElementImpl;
import com.ibm.etools.typedescriptor.InstanceTDBase;
import com.ibm.etools.typedescriptor.TypeDescriptorPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Typed Element</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link com.ibm.etools.c.impl.CTypedElementImpl#getType <em>Type</em>}
 * </li>
 * <li>
 * {@link com.ibm.etools.c.impl.CTypedElementImpl#getContains <em>Contains</em>}
 * </li>
 * <li>
 * {@link com.ibm.etools.c.impl.CTypedElementImpl#getSource <em>Source</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class CTypedElementImpl extends TDLangElementImpl implements CTypedElement {
    /**
     * The cached value of the '{@link #getType() <em>Type</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getType()
     * @generated @ordered
     */
    protected CClassifier type = null;

    /**
     * The cached value of the '{@link #getContains() <em>Contains</em>}'
     * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getContains()
     * @generated @ordered
     */
    protected CDerived contains = null;

    /**
     * The cached value of the '{@link #getSource() <em>Source</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getSource()
     * @generated @ordered
     */
    protected CSourceText source = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CTypedElementImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCTypedElement();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CClassifier getType() {
        if (type != null && type.eIsProxy()) {
            CClassifier oldType = type;
            type = (CClassifier) eResolveProxy((InternalEObject) type);
            if (type != oldType) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, CPackage.CTYPED_ELEMENT__TYPE, oldType, type));
            }
        }
        return type;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CClassifier basicGetType() {
        return type;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setType(CClassifier newType) {
        CClassifier oldType = type;
        type = newType;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CTYPED_ELEMENT__TYPE, oldType, type));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CDerived getContains() {
        return contains;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetContains(CDerived newContains, NotificationChain msgs) {
        CDerived oldContains = contains;
        contains = newContains;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CPackage.CTYPED_ELEMENT__CONTAINS, oldContains, newContains);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContains(CDerived newContains) {
        if (newContains != contains) {
            NotificationChain msgs = null;
            if (contains != null)
                msgs = ((InternalEObject) contains).eInverseRemove(this, CPackage.CDERIVED__CONTAINER, CDerived.class, msgs);
            if (newContains != null)
                msgs = ((InternalEObject) newContains).eInverseAdd(this, CPackage.CDERIVED__CONTAINER, CDerived.class, msgs);
            msgs = basicSetContains(newContains, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CTYPED_ELEMENT__CONTAINS, newContains, newContains));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CSourceText getSource() {
        if (source != null && source.eIsProxy()) {
            CSourceText oldSource = source;
            source = (CSourceText) eResolveProxy((InternalEObject) source);
            if (source != oldSource) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, CPackage.CTYPED_ELEMENT__SOURCE, oldSource, source));
            }
        }
        return source;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CSourceText basicGetSource() {
        return source;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSource(CSourceText newSource) {
        CSourceText oldSource = source;
        source = newSource;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CTYPED_ELEMENT__SOURCE, oldSource, source));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CTYPED_ELEMENT__TD_LANG_SHARED_TYPE:
                if (tdLangSharedType != null)
                    msgs = ((InternalEObject) tdLangSharedType).eInverseRemove(this, TDLangPackage.TD_LANG_CLASSIFIER__TD_LANG_TYPED_ELEMENT, TDLangClassifier.class, msgs);
                return basicSetTdLangSharedType((TDLangClassifier) otherEnd, msgs);
            case CPackage.CTYPED_ELEMENT__INSTANCE_TD_BASE:
                if (instanceTDBase != null)
                    msgs = ((InternalEObject) instanceTDBase).eInverseRemove(this, TypeDescriptorPackage.INSTANCE_TD_BASE__LANGUAGE_INSTANCE, InstanceTDBase.class, msgs);
                return basicSetInstanceTDBase((InstanceTDBase) otherEnd, msgs);
            case CPackage.CTYPED_ELEMENT__CONTAINS:
                if (contains != null)
                    msgs = ((InternalEObject) contains).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CPackage.CTYPED_ELEMENT__CONTAINS, null, msgs);
                return basicSetContains((CDerived) otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CTYPED_ELEMENT__TD_LANG_SHARED_TYPE:
                return basicSetTdLangSharedType(null, msgs);
            case CPackage.CTYPED_ELEMENT__INSTANCE_TD_BASE:
                return basicUnsetInstanceTDBase(msgs);
            case CPackage.CTYPED_ELEMENT__CONTAINS:
                return basicSetContains(null, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CTYPED_ELEMENT__NAME:
            return getName();
        case CPackage.CTYPED_ELEMENT__TD_LANG_SHARED_TYPE:
            if (resolve)
                return getTdLangSharedType();
            return basicGetTdLangSharedType();
        case CPackage.CTYPED_ELEMENT__INSTANCE_TD_BASE:
            if (resolve)
                return getInstanceTDBase();
            return basicGetInstanceTDBase();
        case CPackage.CTYPED_ELEMENT__TYPE:
            if (resolve)
                return getType();
            return basicGetType();
        case CPackage.CTYPED_ELEMENT__CONTAINS:
            return getContains();
        case CPackage.CTYPED_ELEMENT__SOURCE:
            if (resolve)
                return getSource();
            return basicGetSource();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CTYPED_ELEMENT__NAME:
            setName((String) newValue);
            return;
        case CPackage.CTYPED_ELEMENT__TD_LANG_SHARED_TYPE:
            setTdLangSharedType((TDLangClassifier) newValue);
            return;
        case CPackage.CTYPED_ELEMENT__INSTANCE_TD_BASE:
            setInstanceTDBase((InstanceTDBase) newValue);
            return;
        case CPackage.CTYPED_ELEMENT__TYPE:
            setType((CClassifier) newValue);
            return;
        case CPackage.CTYPED_ELEMENT__CONTAINS:
            setContains((CDerived) newValue);
            return;
        case CPackage.CTYPED_ELEMENT__SOURCE:
            setSource((CSourceText) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CTYPED_ELEMENT__NAME:
            unsetName();
            return;
        case CPackage.CTYPED_ELEMENT__TD_LANG_SHARED_TYPE:
            setTdLangSharedType((TDLangClassifier) null);
            return;
        case CPackage.CTYPED_ELEMENT__INSTANCE_TD_BASE:
            unsetInstanceTDBase();
            return;
        case CPackage.CTYPED_ELEMENT__TYPE:
            setType((CClassifier) null);
            return;
        case CPackage.CTYPED_ELEMENT__CONTAINS:
            setContains((CDerived) null);
            return;
        case CPackage.CTYPED_ELEMENT__SOURCE:
            setSource((CSourceText) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CTYPED_ELEMENT__NAME:
            return isSetName();
        case CPackage.CTYPED_ELEMENT__TD_LANG_SHARED_TYPE:
            return tdLangSharedType != null;
        case CPackage.CTYPED_ELEMENT__INSTANCE_TD_BASE:
            return isSetInstanceTDBase();
        case CPackage.CTYPED_ELEMENT__TYPE:
            return type != null;
        case CPackage.CTYPED_ELEMENT__CONTAINS:
            return contains != null;
        case CPackage.CTYPED_ELEMENT__SOURCE:
            return source != null;
        }
        return eDynamicIsSet(eFeature);
    }

} //CTypedElementImpl
